package com.miya.manning.aspect;

import org.apache.log4j.Logger;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;

import java.util.Map;

@Aspect
public class IfConditionAspect {

    private static final Logger log = Logger.getLogger(IfConditionAspect.class);
    /*@Around(value = "execution(* com.miya.manning.vo.conditions.IFCondition.execute(TestCase,List<Script>,String,String,String,Map[]))")*/
    @Around(value = "execution(* com.miya.manning.vo.conditions.IFCondition.execute(..))")
    public Object ifConditionAspect(ProceedingJoinPoint pjp) throws Throwable {
        log.info("开始执行如果控制器切面方法...");
        Object res = null ;
        boolean flag = true;//是否执行标志
        Object[] args = pjp.getArgs();
        String conditions = (String)args[2];
        String expect = (String)args[3];
        String compareType = (String)args[4];
        Map[] maps = (Map[])args[5];
        Map<String,String> string_var_map = maps[0];
        Map<String,Integer> int_var_map = maps[1];
        Map<String,String> res_map = maps[2];
        if("Equals".equals(compareType)){
            log.info("控制器比较类型为:相等");
            if(string_var_map.containsKey(conditions)){
                flag = string_var_map.get(conditions).equals(expect);
                log.info("控制器条件值为:" + string_var_map.get(conditions) + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }
            else if(int_var_map.containsKey(conditions)){
                flag = int_var_map.get(conditions).toString().equals(expect);
                log.info("控制器条件值为:" + int_var_map.get(conditions).toString() + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }
            else if(res_map.containsKey(conditions)){
                flag = res_map.get(conditions).equals(expect);
                log.info("控制器条件值为:" + res_map.get(conditions) + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }else{
                log.info("变量集中未匹配到变量:" + conditions + ",不执行用例");
                flag = false;
            }
            if(flag){
                log.info("开始执行目标方法...");
                res = pjp.proceed();
            }
        }
        if("NotEquals".equals(compareType)){
            log.info("控制器比较类型为:不等");
            if(string_var_map.containsKey(conditions)){
                flag = !string_var_map.get(conditions).equals(expect);
                log.info("控制器条件值为:" + string_var_map.get(conditions) + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }
            else if(int_var_map.containsKey(conditions)){
                flag = !int_var_map.get(conditions).toString().equals(expect);
                log.info("控制器条件值为:" + int_var_map.get(conditions).toString() + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }
            else if(res_map.containsKey(conditions)){
                flag = !res_map.get(conditions).equals(expect);
                log.info("控制器条件值为:" + res_map.get(conditions).toString() + "," + "比较值为:" + expect);
                log.info("控制器条件判断结果为:" + flag);
            }else{
                log.info("变量集中未匹配到变量:" + conditions + ",不执行用例");
                flag = false;
            }
            if(flag){
                log.info("开始执行目标方法...");
                res = pjp.proceed();
            }
        }
        //无论目标方法是否执行,最外层都不需要再执行了
        res = true;
        return res;
    }
}
