package com.miya.manning.aspect;

import org.apache.log4j.Logger;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;

import java.util.Map;

@Aspect
public class LoopConditionAspect {

    private static final Logger log = Logger.getLogger(LoopConditionAspect.class);
    /*@Around(value = "execution(* com.miya.manning.vo.conditions.IFCondition.execute(TestCase,List<Script>,String,String,String,Map[]))")*/
    @Around(value = "execution(* com.miya.manning.vo.conditions.LoopCondition.execute(..))")
    public Object WhileConditionAspect(ProceedingJoinPoint pjp) throws Throwable {
        log.info("开始执行循环控制器切面方法...");
        Object res = null ;
        boolean flag = true;//是否执行标志
        Object[] args = pjp.getArgs();
        String conditions = (String)args[2];
        //String expect = (String)args[3];
        //String compareType = (String)args[4];
        Map[] maps = (Map[])args[5];
        Map<String,String> string_var_map = maps[0];
        Map<String,Integer> int_var_map = maps[1];
        Map<String,String> res_map = maps[2];
        Integer times = Integer.valueOf(conditions);
        log.info("开始执行目标方法,一共需要执行" + times + "次");
        while(times>0){
            pjp.proceed();
            times--;
            log.info("目标方法执行结束,剩余" + times + "次");
        }
        //无论目标方法是否执行,最外层都不需要再执行了
        res = true;
        return res;
    }
}
