package com.miya.manning.framework.request;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.testng.collections.CollectionUtils;

import java.io.*;
import java.net.URI;
import java.util.*;
import java.util.Map.Entry;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.request
 * @ClassName: HTTPGet
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/1/21 下午5:33
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/21 下午5:33
 */
public class HTTPGet {
    public static String httpGet(String url) {
        return httpGet(url, null);
    }

    /*public static String httpGet(String url, String headerContent) {
        HttpClient hc = new DefaultHttpClient();
        HttpGet hg = new HttpGet(url);
        if (StringUtils.isNotBlank(headerContent)) {
            hg.addHeader("authorization", headerContent);
        }

        try {
            HttpResponse response = hc.execute(hg);
            HttpEntity entity = response.getEntity();
            String result = null;
            if (entity != null) {
                result = EntityUtils.toString(entity, "UTF-8");
            }
            return result;
        } catch (ClientProtocolException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        hc.getConnectionManager().shutdown();
        return null;
    }*/

    public static String get(String url,Map<String,String> headerMap,Map<String, String> paramMap) throws ClientProtocolException, IOException {
        HttpClient httpClient = new DefaultHttpClient();
        HttpGet httpGet = new HttpGet();
        Iterator headerIterator = headerMap.entrySet().iterator();          //循环增加header
        while (headerIterator.hasNext()) {
            Entry<String, String> elem = (Entry<String, String>) headerIterator.next();
            httpGet.addHeader(elem.getKey(), elem.getValue());
        }
        if (CollectionUtils.hasElements(paramMap)){
            List<NameValuePair> formparams = setHttpParams(paramMap);
            String param = URLEncodedUtils.format(formparams, "UTF-8");
            httpGet.setURI(URI.create(url + "?" + param));
        }else{
            httpGet.setURI(URI.create(url));
        }
        HttpResponse response = httpClient.execute(httpGet);
        String httpEntityContent = getHttpEntityContent(response);
        httpGet.abort();
        return httpEntityContent;
    }
    private static List<NameValuePair> setHttpParams(Map<String, String> paramMap) {
        List<NameValuePair> formparams = new ArrayList<NameValuePair>();
        Set<Entry<String, String>> set = paramMap.entrySet();
        for (Entry<String, String> entry : set) {
            formparams.add(new BasicNameValuePair(entry.getKey(), entry.getValue()));
        }
        return formparams;
    }
    private static String getHttpEntityContent(HttpResponse response) throws IOException, UnsupportedEncodingException {
        //通过HttpResponse 的getEntity()方法获取返回信息
        HttpEntity entity = response.getEntity();
        if (entity != null) {
            InputStream is = entity.getContent();
            BufferedReader br = new BufferedReader(new InputStreamReader(is, "UTF-8"));
            String line = br.readLine();
            StringBuilder sb = new StringBuilder();
            while (line != null) {
                sb.append(line + "\n");
                line = br.readLine();
            }
            br.close();
            is.close();
            return sb.toString();
        }
        return "";
    }
    public static String httpGet(String url, Map<String, String> httpHeaderMap) {
        HttpClient hc = new DefaultHttpClient();
        HttpGet hg = new HttpGet(url);

        //添加HTTPHeader
        Iterator headerIterator = httpHeaderMap.entrySet().iterator(); //循环增加header
        while (headerIterator.hasNext()) {
            Entry<String, String> elem = (Entry<String, String>) headerIterator.next();
            hg.addHeader(elem.getKey(), elem.getValue());
        }

        //hg.addHeader("authorization", "bearer 65008152-6d0c-484c-8b25-c21e119190af");
        //hg.addHeader("Customer-Id", "121");

        try {
            HttpResponse response = hc.execute(hg);
            HttpEntity entity = response.getEntity();
            String result = null;
            if(entity != null) {
                result = EntityUtils.toString(entity,"UTF-8");
            }
            return result;
        }
        catch(ClientProtocolException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        catch(IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        hc.getConnectionManager().shutdown();
        return null;
    }
}
