package com.miya.manning.framework.util;

import org.springframework.stereotype.Component;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.manning.framework.util
 * @ClassName: 以http header中的参数作为键值对生成map，作为HTTPGet方法的入参
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/4/8 下午10:28
 * @UpdateUser: 梁振振
 * @UpdateDate: 2020/8/7 上午10:28
 */
@Component(value = "HttpHeaderBuilt")
public class HttpHeaderBuilt {

    private static String hhFrom = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "HH-FROM");
    private static String hhApp = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "HH-APP");
    private static String contentType = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "Content-Type");
    private static String hhCi = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "HH-CI");
    private static String merchantId = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "merchant_id");
    private static String couponVerifyType=PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "coupon_verify_type");
    private static String couponVerifyAuth = PropertiesHandle.readValue(StringUtil.HTML_HEADER_FILE_PATH, "coupon_verify_auth");

    public static HashMap httpHeaderBuilt() {
        HashMap headerMap = new HashMap<String, String>();
        headerMap.put("HH-FROM", hhFrom);
        headerMap.put("HH-APP", hhApp);
        headerMap.put("HH-CI", hhCi);
        headerMap.put("Content-Type", contentType);
        return headerMap;
    }
    public static HashMap httpHeaderBuiltEWithAuth(String userToken) throws SQLException {
        HashMap headerMap = new HashMap<String, String>();
        headerMap.put("HH-FROM", hhFrom);
        headerMap.put("HH-APP", hhApp);
        headerMap.put("HH-CI", hhCi);
        headerMap.put("Content-Type", contentType);
        headerMap.put("Authorization", "bearer " + userToken);
        return headerMap;
    }

    public static HashMap httpHeaderBuiltCouponVerify() {
        HashMap headerMap = new HashMap<String, String>();
        headerMap.put("Content-Type", contentType);
        headerMap.put("userInfo", "{\"merchant_id\":"+ merchantId +"}");
        headerMap.put("type", couponVerifyType);
        headerMap.put("Authorization", couponVerifyAuth);
        return headerMap;
    }

    public static Map<String,String> httpHeadBuiltManningsB(Map<String,String> res_map){
        Map<String,String> httpheadermap = new HashMap<>();
        //httpheadermap.put("content-type","application/json");
        httpheadermap.put("authorization", res_map.containsKey("varg_data_0_token")? res_map.get("varg_data_0_token") : "");
        httpheadermap.put("type", "unioncenter");
        return httpheadermap;

    }


    public static Map<String,String> httpHeadBuiltManningsC(Map<String,String> string_var_map ,Map<String,Integer> int_var_map){
        Map<String,String> httpheadermap = new HashMap<>();
        httpheadermap.put("hh-app","wxc836213220ab21fb");
        httpheadermap.put("hh-from","149");
        httpheadermap.put("hh-from-id","149");
        httpheadermap.put("traceid","");
        httpheadermap.put("hh-ci","saas-wechat-app");
        httpheadermap.put("content-type","application/json");
        httpheadermap.put("access_token", string_var_map.containsKey("varg_access_token")? string_var_map.get("varg_access_token") : "");
        httpheadermap.put("authorization", string_var_map.containsKey("varg_access_token")? "bearer " + string_var_map.get("varg_access_token") : "");
        httpheadermap.put("shareUid", "");
        httpheadermap.put("sence","");
        httpheadermap.put("userId","");
        httpheadermap.put("c-user-id",int_var_map.containsKey("varg_user_id")? int_var_map.get("varg_user_id").toString() : "");
        httpheadermap.put("c-member-id",int_var_map.containsKey("varg_member_id")? int_var_map.get("varg_member_id").toString() : "");
        httpheadermap.put("c-bind-store-id",int_var_map.containsKey("varg_bind_store_id")? int_var_map.get("varg_bind_store_id").toString() : "");
        return httpheadermap;

    }
}

