package com.miya.manning.framework.util;


import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import java.util.*;

public class JsonTransfer {
    private static String start_with = "varg_";
    public static JSONObject ToJsonObject(String req){
        return JSONObject.fromObject(req);
    }

    public static JSONArray ToJsonArray(String req){
        return JSONArray.fromObject(req);
    }

    public static boolean AnalysisJson(String response, Map map ,String orgin ,int num){
        if(response.indexOf(":") == -1){
            //value中没有：表示该json不需要继续解析了
            return true;
        }
        JSONObject fromObject = JSONObject.fromObject(response);
        Iterator it = fromObject.keys();
        while(it.hasNext()){
            String key =  it.next().toString();
            String value = fromObject.get(key).toString();
            if(value.startsWith("[{") && value.indexOf("[{") != -1){
                //表明该value中包含jsonarray类型的数据
                //去除[号
                String jsons = value.substring(1, value.lastIndexOf("]"));
                jsons = ArrayInObject(jsons);
                jsons = jsons.replaceAll("\\}\\s?,\\s?\\{", "}|{");//替换成{}|{}格式，方便分割
                String[] split = jsons.split("\\|");
                for(int i = 0 ; i<split.length ;i++){
                    String orgin1 = orgin + "_" + num + "_" + key;
                    String sub = split[i];
                    //System.out.println(sub);
                    sub = sub.replaceAll("\\+", "}");//外层分割好后,再把-替换回}
                    AnalysisJson(sub,map,orgin1,i);
                }
            }else if (value.indexOf("{") != -1){
                //表明该value中包含jsonobject类型的数据
                String orgin1 = orgin+"_" + num + "_" +key ;
                AnalysisJson(value, map, orgin1,num);
            }else{
                //普通的value
                map.put(orgin + "_"  + num + "_" + key ,value);
            }

        }
        return false;
    }
    public static Map<String,String> AnalysisJson(String response, Map<String,String> map ){
        if(response.indexOf(":") == -1){
            //value中没有：表示该json不需要继续解析了
            return map;
        }
        JSONObject fromObject = JSONObject.fromObject(response);
        Iterator it = fromObject.keys();
        while(it.hasNext()){
            String key =  it.next().toString();
            String value = fromObject.get(key).toString();
            if(value.startsWith("[{") && value.indexOf("[{") != -1){
                String jsons = value.substring(1, value.lastIndexOf("]"));
                /*此处有问题,如果jsonarray中嵌套了jsonarray并且内部有多个对象,会有截断*/
                jsons = ArrayInObject(jsons);
                jsons = jsons.replaceAll("\\}\\s?,\\s?\\{", "}|{");//替换成{}|{}格式，方便分割
                String[] split = jsons.split("\\|");
                for(int i = 0 ; i<split.length ;i++){
                    String orgin = start_with+key;
                    String sub = split[i];
                    //System.out.println(sub);
                    sub = sub.replaceAll("\\+", "}");//外层分割好后,再把-替换回}
                    AnalysisJson(sub,map,orgin,i);
                }
                //表明该value中包含jsonarray类型的数据
            }else if (value.indexOf("{") != -1){
                //表明该value中包含jsonobject类型的数据
                String orgin = start_with+key;
                AnalysisJson(value, map, orgin,0);
            }else{
                //普通的value
                map.put(start_with+key,value);
            }

        }
        return map;
    }

    /***
     *
     * @param jsonobject_str jsonarray中提取出来的jsonobject字符串,可能包含多个对象{},{}
     * @return jsonobject中嵌套的jsonarray,将}替换成+返回
     */
    public static String ArrayInObject(String jsonobject_str){
        Map<Character, Character> pairs = new HashMap<Character, Character>() {{
            put(')', '(');
            put(']', '[');
            put('}', '{');
        }};
        List<Integer> need_replace_index  = new ArrayList<>();
        Deque<Character> stack = new LinkedList<>();
        StringBuffer sb = new StringBuffer();
        if(jsonobject_str.contains("[")){
            int first_index = jsonobject_str.indexOf("[");
            for(int i = first_index;i<jsonobject_str.length();i++){//从[开始的地方进行压栈,栈顶如果有'{',且下一个压栈的字符是'}'时,说明array中的一个object结束了,需要把这个位置记下来,后续需要替换成+
                                                                   // 最后格式为{[{+,{+]},{[{+,{+]} ,外层是匹配},{替换为}|{后用|分割,方便内层array的对象和外层的分隔符区分开
                char ch = jsonobject_str.charAt(i);
                if(pairs.containsKey(ch)){
                    if( !stack.isEmpty() && stack.peek() == pairs.get(ch)){
                        stack.pop();
                        if(ch!=']'){//弹栈时,如果是array的结束符']',则不需要记录下标位置,因为只有数组中对象的}需要和外层进行区分
                            need_replace_index.add(i);
                        }
                    }
                }if ((stack.isEmpty() && ch =='[') || (!stack.isEmpty() &&( ch == '{' || ch =='['))) {//过滤其他字符,只针对代表array和object的起始字符和结束字符
                    //正常的嵌套格式,例如{[{obj1},{obj2}]},{[{obj3},{obj4}]},只有栈为空的时候遇到[会压栈,表示内部开始有嵌套数组了;或者栈内已经有数据了,再次遇到{,表示当前数组中的对象开始解析到了;再次遇到[表示又嵌套了一层新的数组
                    //这些都需要进行压栈
                    stack.push(ch);
                }
            }
            if(!need_replace_index.isEmpty()){
                for(int j = 0 ; j< jsonobject_str.length() ; j++){
                    if(need_replace_index.contains(j)){
                        sb.append('+');
                    }
                    else{
                        sb.append(jsonobject_str.charAt(j));
                    }
                }
            }
            else{
                sb.append(jsonobject_str);//如果是这种类型的数组{"a":xxx,"b":[],"c":zzz},{"a":xxx,"b":[],"c":zzz,"d":7},则没有需要替换成"+"的"}"字符,则原封不动返回
            }
            return sb.toString();
        }
        return jsonobject_str;
    }

    public static void main(String[] args) {
        ArrayInObject("{\"a\":xxx,\"b\":[7],\"c\":zzz},{\"a\":xxx,\"b\":[8],\"c\":zzz,\"d\":[{\"e\":1,\"f\":2},{\"e\":3,\"f\":4}]}");
        //ArrayInObject("{\"onlyGift\":false,\"goodsId\":8694,\"goodsSort\":2411,\"storeGoodsId\":22217,\"brandId\":158,\"goodsCode\":\"111043528\",\"goodsName\":\"万宁饮用天然矿泉水600ml\",\"barcode\":\"9556135003344\",\"summary\":\"\",\"price\":250,\"stock\":75,\"detailIconUrls\":\"\",\"videoUrl\":\"\",\"display\":1,\"brandLabel\":null,\"expressTemplateId\":1,\"labelNameList\":[],\"memberPrice\":null,\"thirdCategoryIds\":[109],\"labelIds\":[17]},{\"onlyGift\":false,\"goodsId\":7569,\"goodsSort\":450,\"storeGoodsId\":13749,\"brandId\":3176,\"goodsCode\":\"111042119\",\"goodsName\":\"芙丝饮用天然矿泉水500ml\",\"barcode\":\"6970920140022\",\"summary\":\"\",\"price\":750,\"stock\":3,\"videoUrl\":\"\",\"display\":1,\"brandLabel\":null,\"expressTemplateId\":1,\"labelNameList\":[],\"memberPrice\":null,\"thirdCategoryIds\":[109],\"labelIds\":null}");
    }

}



