package com.miya.manning.framework.util;

import java.io.*;
import java.util.Properties;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.util
 * @ClassName: PropertiesHandle
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/1/22 下午2:53
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/22 下午2:53
 */
public class PropertiesHandle {

    public static String readValue(String key) {
        Properties props = new Properties();
        try {
            //InputStream in = new BufferedInputStream(new FileInputStream("/Users/Ryan/Git/MY/Test/MY_INTERFACE_TEST/src/main/resources/config.properties"));
            InputStream in = new BufferedInputStream(new FileInputStream("src/main/resources/config.properties"));
            //InputStream in = new BufferedInputStream(new FileInputStream("config.properties"));
            props.load(in);
            String value = props.getProperty(key);
            return value;
        }
        catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String readValue(String filename, String key) {
        Properties props = new Properties();
        try {
            InputStream in = new BufferedInputStream(new FileInputStream(filename));
            props.load(in);
            String value = props.getProperty(key);
            return value;
        }
        catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String readSpecialValue(String fileName, String key) {
        Properties props = new Properties();
        try {
            InputStreamReader in = new InputStreamReader(new FileInputStream(fileName), "UTF-8");
            props.load(in);
            String value = props.getProperty(key);
            return value;
        }
        catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String readTempValue(String key) {
        Properties props = new Properties();
        try {
            InputStreamReader in = new InputStreamReader(new FileInputStream(StringUtil.TEMP_PARAM_FILE_PATH), "UTF-8");
            props.load(in);
            String value = props.getProperty(key);
            return value;
        }
        catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static void writeValue(String fileName, String key, String value) {
        Properties props = new Properties();
        try {
            InputStreamReader in = new InputStreamReader(new FileInputStream(fileName), "UTF-8");
            props.load(in);
            if (props.containsKey(key)){
                props.replace(key, value);
            }else{
                props.setProperty(key, value);
            }
            clearFile(fileName);
            FileOutputStream oFile = new FileOutputStream(fileName, true);
            props.store(oFile, "Add properties: " + key);
            oFile.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            try {
                FileOutputStream oFile = new FileOutputStream(fileName, true);
                props.setProperty(key, value);
                props.store(oFile, "Add properties: " + key);
                oFile.close();
            }catch (Exception e1){
                e1.printStackTrace();
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void writeTempValue(String key, String value) {
        try {
            writeValue(StringUtil.TEMP_PARAM_FILE_PATH, key, value);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void deleteValue(String fileName, String key) {
        Properties props = new Properties();
        try{
            InputStreamReader in = new InputStreamReader(new FileInputStream(fileName), "UTF-8");
            props.load(in);
            props.remove(key);
            FileOutputStream oFile = new FileOutputStream(fileName);
            props.store(oFile, "Delete properties: " + key);
            oFile.close();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void clearFile(String fileName) {
        Properties props = new Properties();
        try{
            props.clear();
            FileOutputStream oFile = new FileOutputStream(fileName);
            props.store(oFile, "clear");
            oFile.close();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }


}
