package com.miya.manning.framework.util;

import com.miya.manning.enums.ConditionType;
import com.miya.manning.enums.ScriptType;
import com.miya.manning.vo.conditions.Condition;
import com.miya.manning.vo.conditions.ExcuteableCondition;
import com.miya.manning.vo.scripts.JavaScript;
import com.miya.manning.vo.scripts.SSHScript;
import com.miya.manning.vo.scripts.Script;
import com.miya.manning.vo.testcase.TestCase;
import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import java.util.List;
import java.util.Map;

public class ToolUtil {
    private static final Logger log = Logger.getLogger(ToolUtil.class);
    private static ApplicationContext ac = new ClassPathXmlApplicationContext("ApplicationContext.xml");

    public static void ExecuteScript(List<Script> execScriptList) throws Exception {
        //ExcuteableScript script = null;
        //ScriptFactory scriptFactory = (ScriptFactory) ac.getBean("ScriptFactory");
        //List<Script> list_script =scriptList.stream().filter(x -> x.getScript_name().equals(testCase.getScript_name())).collect(Collectors.toList());
        if(execScriptList.size() == 0) {
            throw new Exception("没有匹配到脚本！");
        }if(execScriptList.size() >1 ){
            throw new Exception("匹配到多个同名脚本！");
        }else{
            Script sc = execScriptList.get(0);
            if(ScriptType.JAVA_SCRIPT.getType().equals(sc.getSrcipt_type())){
                JavaScript javaScript = (JavaScript) ac.getBean("javaScript");
                log.info("开始执行java脚本：" + sc.getScript_name());
                javaScript.execute(sc.getScript_param());
            }
            if(ScriptType.SSH_SCRIPT.getType().equals(sc.getSrcipt_type())){
                SSHScript sshScript = (SSHScript) ac.getBean("sshScript");
                log.info("开始执行ssh脚本：" + sc.getScript_name());
                sshScript.execute(sc.getScript_param());
            }
            /*Class<?> clz = Class.forName("com.miya.manning.vo.scripts.ScriptFactory");
            Script sc = execScriptList.get(0);
            Method method =  clz.getDeclaredMethod("create" + sc.getSrcipt_type() + "Script",String.class);
            if(ScriptType.JAVA_SCRIPT.getType().equals(sc.getSrcipt_type())){
                script = (JavaScript) method.invoke(scriptFactory,sc.getScript_param());
                log.info("开始执行脚本：" + sc.getScript_name());
                script.excute(sc.getScript_param());
            }
            if(ScriptType.SSH_SCRIPT.getType().equals(sc.getSrcipt_type())){
                script = (SSHScript) method.invoke(scriptFactory,sc.getScript_param());
                log.info("开始执行脚本：" + sc.getScript_name());
                script.excute(sc.getScript_param());
            }*/

        }
    }
    public static boolean ExecuteCondition(List<Condition> execConditionList , List<Script> scripts, TestCase testCase , Map... var_maps) throws Exception{
        boolean flag = true;
        if(execConditionList.size() == 0) {
            throw new Exception("没有匹配到控制器！");
        }if(execConditionList.size() >1 ){
            throw new Exception("匹配到多个同名控制器！");
        }else{
            Condition cd = execConditionList.get(0);
            String condition = cd.getCondition_param();
            String expect = cd.getCondition_expect();
            String compare_type = cd.getCondition_compare_type();
            if(ConditionType.IF_CONDITION.getType().equals(cd.getCondition_type())){
                ExcuteableCondition ifCondition = (ExcuteableCondition) ac.getBean("ifCondition");
                log.info("开始执行如果控制器：" + cd.getCondition_name());
                flag = ifCondition.execute(testCase,scripts,condition,expect,compare_type,var_maps);
            }
            if(ConditionType.LOOP_CONDITION.getType().equals(cd.getCondition_type())){
                ExcuteableCondition whileCondition = (ExcuteableCondition) ac.getBean("loopCondition");
                log.info("开始执行循环控制器：" + cd.getCondition_name());
                flag = whileCondition.execute(testCase,scripts,condition,expect,compare_type,var_maps);
            }
    }
        return flag;
}
}
