package com.miya.manning.framework.util.redisutil;

import com.miya.manning.framework.util.StringUtil;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

import java.io.IOException;
import java.util.Properties;

/**
 * @ProjectName: MY_INTERFACE_TEST
 * @Package: com.miya.interfacetest.framework.util.redisutil
 * @ClassName: RedisUtil
 * @Description: java类作用描述
 * @Author: 唐奇良
 * @CreateDate: 2019/1/22 上午10:47
 * @UpdateUser: 更新者
 * @UpdateDate: 2019/1/22 上午10:47
 */
public class RedisUtil {

    public static JedisPool jedisPool;

    static {
        Properties prop = new Properties();
        try {
            prop.load(RedisUtil.class.getClassLoader().getResourceAsStream(StringUtil.REDIS_FILE_PATH));
            JedisPoolConfig config = new JedisPoolConfig();
            config.setMaxTotal(Integer.valueOf(prop.getProperty("jedis.pool.maxTotal")));
            config.setMaxIdle(Integer.valueOf(prop.getProperty("jedis.pool.maxIdle")));
            config.setMaxWaitMillis(Long.valueOf(prop.getProperty("jedis.pool.maxWaitMillis")));
            config.setTestOnBorrow(Boolean.valueOf(prop.getProperty("jedis.pool.testOnBorrow")));
            config.setTestOnReturn(Boolean.valueOf(prop.getProperty("jedis.pool.testOnReturn")));

            //根据配置实例化jedis池
            jedisPool = new JedisPool(config, prop.getProperty("redis.ip"), Integer.valueOf(prop.getProperty("redis.port")),Integer.valueOf(prop.getProperty("jedis.pool.timeout")),prop.getProperty("jedis.pool.auth"));
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    /**获得jedis对象*/
    public static Jedis getJedisObject(){
        return jedisPool.getResource();
    }


    /**归还jedis对象*/
    public static void recycleJedisOjbect(Jedis jedis){
        jedisPool.returnResource(jedis);
    }

    public static String getToken(Jedis jedis){
        return jedis.get("name");
    }

//    public static void main(String[] args) {
//
//        Jedis jedis = getJedisObject();//获得jedis实例
//
//        //获取jedis实例后可以对redis服务进行一系列的操作
//
//        jedis.set("name", "zhuxun");
//
//        System.out.println(jedis.get("name"));
//        System.out.println("token===="+getToken(jedis));
////
////        jedis.del("name");
////        jedis.del("nameq");
////        System.out.println(jedis.exists("name"));
//
//
//        recycleJedisOjbect(jedis); //将 获取的jedis实例对象还回
//
//    }

}