package com.miya.manning.test.flow.order;

import com.miya.manning.framework.util.TestCaseUtil;
import com.miya.manning.framework.util.TestUtil;
import com.miya.manning.vo.conditions.Condition;
import com.miya.manning.vo.scripts.Script;
import com.miya.manning.vo.testcase.TestCase;
import org.apache.log4j.Logger;
import org.testng.annotations.*;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

/**
 * @ProjectName: manning_test
 * @Package: com.miya.manning.test.flow.order.Delivery
 * @ClassName: Mainprocess
 * @Description: 万宁物流模块测试
 * @Author: 熊军奕
 * @CreateDate: 2022/5/23 下午22:38
 * @UpdateUser: 熊军奕
 * @UpdateDate: 2022/5/23 下午22:38
 */
public class Delivery_process {

    static Logger logger = Logger.getLogger(Delivery_process.class);
    private String url_start = "https://cs2-uat.mannings.com.cn/";
    private String script_path = System.getProperty("user.dir") + File.separator + "target" + File.separator + "classes"
            + File.separator + "testcase" + File.separator + "Scripts" + File.separator + "Script.xls";
    private String condition_path = System.getProperty("user.dir") + File.separator + "target" + File.separator + "classes"
            + File.separator + "testcase" + File.separator + "Conditions" + File.separator + "Condition.xls";
    private String path = System.getProperty("user.dir") + File.separator + "target" + File.separator + "classes" +
            File.separator + "testcase" + File.separator + "Delivery_process.xls";
    //private String path = "D:\\autotest\\test_liucheng\\test_liucheng\\huihua_saas1.xls";
    private Map<String,String> res_map = new TreeMap<>();
    private static Map<String,Integer> int_var_map = new HashMap<>();
    private static Map<String,String> string_var_map = new HashMap<>();
    private static List<Script> Scripts = null;
    private static List<Condition> Conditions = null;


    @DataProvider(name = "ex")
    public Object[][] Parameter(){

        /*return new Object[][]{
                {1,10, "200", "null", null},//查询券列表
                {2,10, "200", "null", null},//查询券列表第二页
                //{ "200", "null", null},//
        };*/
        Object[][] testcases = null;
        try {
            Scripts = TestCaseUtil.GetScripts(script_path);
            Conditions = TestCaseUtil.GetConditions(condition_path);
            testcases = TestCaseUtil.GetMain(path);
        } catch (RuntimeException e) {
            logger.error("error:" , e );

        }
        return testcases;
    }

    @BeforeClass
    public void setUp() {
        logger.info("闪送订单主流程测试开始！");
    }

    @AfterClass
    public void tearDown() {

        logger.info("闪送订单主流程测试结束！");
        for (Map.Entry<String, String> entry : res_map.entrySet())
            logger.info(entry.getKey() + ":" + entry.getValue());
    }

    @BeforeMethod
    public void before(){
    }


    @Test(dataProvider = "ex")
    public void Delivery( TestCase testCase) throws Exception {
        TestUtil.doTest(testCase,string_var_map,int_var_map,res_map,Scripts,Conditions,url_start);









        /*if (code == "200") {
            Response response = new Response(final_res.getString("code"), final_res.getString("msg"), final_res.getJSONObject("data"));
            JSONObject final_res_data = (JSONObject) response.getData();
            Assert.assertEquals(response.getCode(), code);
            Assert.assertEquals(response.getMsg(), msg);


            String manufacturer_id =PropertiesHandle.readValue(StringUtil.httpHeader, "manufacturerId");
            List<CouponConfigPO> couponGetPagelist = CouponSql.couponGetPage(manufacturer_id,pageNum,pageSize);
            for (int i = 0; i< couponGetPagelist.size(); i++) {
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("manufacturerId"),couponGetPagelist.get(i).getManufacturerId());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("picUrl"),couponGetPagelist.get(i).getPicUrl());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("couponScene"),couponGetPagelist.get(i).getCouponScene());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("couponName"),couponGetPagelist.get(i).getCouponName());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("couponRights"),couponGetPagelist.get(i).getCouponRights());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("couponType"),couponGetPagelist.get(i).getCouponType());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("couponBatch"),couponGetPagelist.get(i).getCouponBatch());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("instructions"),couponGetPagelist.get(i).getInstructions());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getString("state"),couponGetPagelist.get(i).getState());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getInt("costScore"),couponGetPagelist.get(i).getCostScore());
                Assert.assertEquals(final_res_data.getJSONArray("list").getJSONObject(i).getInt("userDailyGetLimit"),couponGetPagelist.get(i).getUserDailyGetLimit());
            }


        } else {
            Response response = new Response(final_res.getString("code"), final_res.getString("msg"), final_res.getString("data"));
            Assert.assertEquals(response.getCode(), code);
            Assert.assertEquals(response.getMsg(), msg);
            Assert.assertEquals(response.getData(), data);
        }*/
    }



}
